/********************************************************************/
#INCLUDE ../EPROM.H
MAXERR=3; MODE=NOLSTOP,DEBUG; /* +T*/ /*+M */ ! Enable: remove  gap
#IFDEF P_PPC;
   #IF EPROM
      SC=$7000,CODE=$0,VAR=$0;
   #ELSE
      SC=6900;
   #FIN;
#FIN;
#IFDEF P_68K;
   #IF EPROM
      SC=$5000,CODE=$0,VAR=$0;
   #ELSE
      SC=4D8C;
   #FIN;
#FIN;

SHELLMODULE HTTP_INI; /*+T */ /*+M */
HTTPINI:'HTTP_INI';
SYSTEM;
!HTP_INI_TERM: /TY<->;
INPFILEMASK:/NIL/ksjkdjskdjksjdksjdksjdks(NE)<->;
PROBLEM;

!SPC HTP_INI_TERM DATION INOUT ALPHIC;
SPC INPFILEMASK DATION INOUT ALPHIC;
SPC ENVGET PROC(CHAR(255)) RETURNS(CHAR(255)) GLOBAL;

#DEFINE INIT_TEMPLATES = 1;
#INCLUDE ../INCLUDE/INIVAR.INC

DCL ErrPool(8) CHAR(15) INIT(
                'Undefined Var  ',
                'Syntax error   ',
                'File read error',
                'Insuff. memory ',
                'Internal error ',
                'Double defined ',
                'Var list overfl',
                'Limit exceeded ');

#INCLUDE ../INCLUDE/INIPROC.INC

! *******************************************************************
!  The shell-entry is here:
! *******************************************************************

HTTPINI : PROC((Stdin,Stdout,Stderr) DATION INOUT ALPHIC IDENT,
                  Length FIXED, Text CHAR(255)) RETURNS(BIT(1));

DCL FILEX DATION IN ALPHIC CREATED(INPFILEMASK);   ! Internal File
DCL INIPATH CHAR(255);
DCL Dummy CHAR(12);
DCL (Itemp,Itemp2) FIXED(31);
DCL VPTR REF STRUCT[];
DCL C255PTR REF CHAR(255);
DCL C1PTR REF CHAR(1);
DCL FRMFIL DATION OUT ALPHIC CREATED(INPFILEMASK);
DCL Tabversion CHAR(8);    ! Actual version
DCL VARTAB(VARTABLEN) VARENTRY;
DCL TxtPool(TXTPOOLLEN) CHAR(10);
DCL Nexttxt FIXED(31) INIT(6);

 PUT '    *** Welcome to the HTTP-Server Initialisation utility! ***' TO Stdout
    BY SKIP,A,SKIP,SKIP;
 IF Length GT 1 THEN
    Dummy=ENVGET('$HTTPINIDIR');
    IF Dummy.CHAR(1) NE '$' THEN
       PUT 'You have overridden an existing environment-variable $HTTPINIDIR=',
         Dummy TO Stdout BY A,A,SKIP;
    ELSE
      Dummy=ENVGET('$HTTPDIR');
      IF Dummy.CHAR(1) NE '$' THEN
         PUT 'You have overridden an existing environment-variable $HTTPDIR=',
           Dummy TO Stdout BY A,A,SKIP;
      FIN;
    FIN;
    INIPATH=Text;
 ELSE
    INIPATH=ENVGET('$HTTPINIDIR');
    IF INIPATH.CHAR(1) == '$' THEN
      INIPATH=ENVGET('$HTTPDIR');
      IF INIPATH.CHAR(1) == '$' THEN
        PUT 'You must set the environment $HTTPDIR (path) before!',
            'You can specify this alternatively by argument of INI_HTTP.'
            TO Stdout BY A,SKIP,A,SKIP;
        PUT 'Command aborted.' TO Stdout BY SKIP,A,SKIP;
        RETURN ('1'B);
      FIN;
    FIN;
 FIN;


 PUT 'Please check, if the following directory is legal for reading the',
     'file HTTPSERV.INI and writing the frame into file HTTPSERV.FRM:',
     '   >>> ',INIPATH,' <<<' TO Stdout BY A,SKIP,A,SKIP(2),A,A(LEN(INIPATH)),A,SKIP(2);
 PUT 'Press Enter if o.k. --  Type A(a)+Enter for abort:'
     TO Stdout BY A;
 GET Dummy FROM Stdin BY A;
 IF Dummy.CHAR(1) == 'A' OR Dummy.CHAR(1)=='a' THEN
    PUT 'INI_HTTP aborted.' TO Stdout BY SKIP,A,SKIP;
    RETURN ('1'B);
 FIN;

 PUT TO Stdout BY SKIP;
 Tabversion = Tabversionreq;
 TableInit( VARTAB, TxtPool, Nexttxt ) ;
 IF INIPATH.CHAR(LEN(INIPATH)) NE '/' THEN
    INIPATH.CHAR(LEN(INIPATH)+1) = '/';
 FIN;

 INIPATH=KON(INIPATH,1,LEN(INIPATH),'HTTPSERV.INI',1,13);
 Itemp=INIREAD(FILEX,VARTAB,TxtPool,INIPATH,Nexttxt);
 Itemp2=Itemp//10000(31);

 IF Itemp2 == 0 AND VARTAB(1).IValue == 0 THEN
    PUT '*** You must at least specify the ip-adr (OWN_IP) of target! ***',
        'Please insert OWN_IP = vvv.xxx.yyy.zzz into file HTTPSERV.INI',
        'and start program again! Check also IP_ALLOW1 and IP_MASK1.'
        TO Stdout BY (3)(A,SKIP);
    RETURN('1'B);
 FIN;


 CASE Itemp2
   ALT(0)  PUT 'All lines processed, no errors.' TO Stdout BY A,SKIP;
           PUT 'The following will be coded in HTTPSERV.FRM:'
               TO Stdout BY A,SKIP(2);

           FOR I TO 1 UPB VARTAB REPEAT
             IF VARTAB(I).Name.CHAR(1) NE '*' THEN
               CASE VARTAB(I).Descr
                 ALT(vtNumVal)
                        PUT VARTAB(I).Name,'= ' TO Stdout BY A,A;
                        PUT VARTAB(I).IValue TO Stdout BY F(8),SKIP;
                 ALT(vtTextStr,vtFileType,vtApplication,vtApplication2,vtApplication3,vtDirAlias,vtRealm,vtAuthenticate)
                        CASE VARTAB(I).Descr
                          ALT(vtTextStr) PUT 'TextString ',VARTAB(I).Name,'= ' TO Stdout BY A,A,A;
                          ALT(vtFileType) PUT 'FileType ',VARTAB(I).Name,'= ' TO Stdout BY A,A,A;
                          ALT(vtApplication) PUT 'Application ',VARTAB(I).Name,'= ' TO Stdout BY A,A,A;
                          ALT(vtApplication2) PUT 'Application2 ',VARTAB(I).Name,'= ' TO Stdout BY A,A,A;
                          ALT(vtApplication3) PUT 'Application3 ',VARTAB(I).Name,'= ' TO Stdout BY A,A,A;
                          ALT(vtDirAlias) PUT 'DirAlias ',VARTAB(I).Name,'= ' TO Stdout BY A,A,A;
                          ALT(vtRealm) PUT 'Realm ',I,VARTAB(I).Name,'= ' TO Stdout BY A,F(3),X,A,A;
                          ALT(vtAuthenticate) PUT 'Authenticate ',VARTAB(I).Name,'= ' TO Stdout BY A,A,A;
                          OUT PUT 'Unknown ',VARTAB(I).Name,'= ' TO Stdout BY A,A,A;
                        FIN;
                        VPTR=TxtPool(VARTAB(I).IValue).CHAR(1);
                        C255PTR=VPTR;
                        PUT C255PTR TO Stdout BY A(VARTAB(I).Len),SKIP;
                 ALT(vtIPAddr)
                        PUT VARTAB(I).Name,'= ' TO Stdout BY A,A;
                        VPTR=VARTAB(I).IValue;
                        C1PTR=VPTR;
                        PUT TOFIXED(C1PTR),'.' TO Stdout BY F(3),A;
                        REFADD(C1PTR,1);
                        PUT TOFIXED(C1PTR),'.' TO Stdout BY F(3),A;
                        REFADD(C1PTR,1);
                        PUT TOFIXED(C1PTR),'.' TO Stdout BY F(3),A;
                        REFADD(C1PTR,1);
                        PUT TOFIXED(C1PTR) TO Stdout BY F(3),SKIP;

               FIN;
             FIN;
           END;
           PUT 'Text-pool used:',((Nexttxt-1)*100)/(1 UPB TxtPool),' %',
               'Var-pool  used:',((SERID(VARTAB,EMPTY,vtUnused)-1)*100)/(1 UPB VARTAB),
               ' %' TO Stdout BY SKIP,(2)(A,F(3),A,SKIP);
           INIPATH=KON(INIPATH,1,LEN(INIPATH)-3,'FRM',1,3);
           OPEN FRMFIL BY IDF(INIPATH),ANY;
           IF ST(FRMFIL) NE 0 THEN
             PUT 'Cannot open output-file',INIPATH,',  program aborted!'
                TO Stdout BY A,A(LEN(INIPATH)),A,SKIP;
                RETURN('1'B);
           FIN;
           REWIND (FRMFIL);
           WRITE Tabversion,VARTAB,TxtPool TO FRMFIL;
           CLOSE FRMFIL;
           IF ST(FRMFIL) == 0 THEN
             PUT 'Writing file ',INIPATH,' O.K.' TO Stdout BY A,
                A(LEN(INIPATH)),A,SKIP;
           ELSE
             PUT 'Error writing or closing file ',INIPATH,' !' TO
                Stdout BY A,A(LEN(INIPATH)),A,SKIP;
           FIN;
           RETURN('1'B);

   ALT(1:8) PUT 'Error in Line',Itemp-Itemp2*10000(31),' : "',
                ErrPool(Itemp2),'"' TO Stdout
                BY A,F(4),A,A(LEN(ErrPool(Itemp2))),A,SKIP;
            PUT INIPATH TO Stdout BY A(LEN(INIPATH)),SKIP;
            PUT 'Please correct error and start again!' TO Stdout
                BY SKIP,A,SKIP;
            RETURN('1'B);

 FIN;

 RETURN('1'B);

END;

MODEND DEBUG;
